/*
**	deconv.c
*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/file.h>
#include <math.h>

#define OLOP	1

/* PSF size
for 2766 #define H 6 #define V 10
for 3026 #define H 12 #define V 8
*/
#define H 12
#define V 8

/* size
Stained Glass   #define SX 1280 #define SY 960
Victory gatecut #define SX 1024 #define SY 560
op2 #define SX 1280 #define SY 960
#define SX 512  #define SY 512
op  #define SX 1600 #define SY 1200
*/
#define SX 512
#define SY 512

#define GE		// global estimate image
#define FULL
//#define PART
//#define DIVD	// Divide

#ifdef DIVD
#define DX 4
#define DY 4
#else
#define DX 1
#define DY 1
#endif

// process image buffer size
#define PX (SX/DX + H + DX)
#define PY (SY/DY + V + DY)

//#define VSEP
#define M (H/2)
#define Fs 64 // Fs >= H
#define U (V/2)
#define P (H)
#define N (P*P)
//---------------------------selections-----------------------------------------
//#define TST
//#define LPC
//#define Wiener
//#define INV_MAT
//#define IIR_INV
#define FP (1.2)
#define FP1 (0.5)
//#define IIR_INV1
#define IIR_INV2

//#define RECALC	// error recalc
#define BEST		// distingish ests before/after change
#ifdef BEST
#define best es0	// estmate before change
#else
#define best es		// estimate changing or after change
#endif

#ifdef GE
#define es(y,x) est[sy+y][sx+x]
#define es0(y,x) est0[sy+y][sx+x]
#define in(y,x) inp[sy+y][sx+x]
#define EX SX
#define EY SY
#else
#define es(y,x) est[y][x]
#define es0(y,x) est0[y][x]
#define in(y,x) inp[y][x]
#define EX PX
#define EY PY
#endif

//----initial PSF is started by 
#define FLAT
//#define HALF
//#define YASUK
//#define PSF2	// first
//#define PSF3	// for mid

//-------------------------typedefs---------------------------------------------

typedef unsigned char	Uc;
typedef double		Ft;	// fft data type
typedef double		Mt;	// mat[][] data type
typedef double		dbt;
typedef struct{ Uc y[SY  ][SX  ]; Uc c[2][SY/2][SX/2]; }Sif;
typedef struct{ Uc y[SY/2][SX/2]; Uc c[2][SY/4][SX/4]; }Sif2;
typedef struct{ Ft re; Ft im; } complex;
typedef struct{ int x; int y; } pos;
typedef struct{ pos s; pos e; } rect;

//------------------------static variables-------------------------------------
int accl= 4;	// accellation value
int estm= 1;	// 0:alg0 (error deliver to estimated image by psf)
		// 1:alg1 (err ddeliver to est by psf*est with normalization)
		// 2:lucy // Lucy's algorithm 
int psfm= 2;	// 1:lucy rate(chi)^accl * est(xi) (Lucy's PSF modification)
		// 2:adl  not calc 	(deliver same error to est and psf)
		// 3:smpl error(chi)^accl (>th) * est(xi)
int pr= 0;
int iloop= 100;
int use_gamma= 1;
int use_expand= 0;	// output [16,255]to[0,255] (for 601 video luma only)
extern int grid;
int peak_pos_x;
int peak_pos_y;

static	Sif	in,ou,ot;	// images
static	Sif2	in2,ou2,ot2;	// shrinked images
static	Mt	mat2[V][H];	// input h(l,k)
static	Mt	mat3[V][H];	// modified h(l,k)
static	Mt	mat4[V][H];	// highpass
static	Mt	psfa[DY][DX][V][H];	// PSF array
#ifdef VSEP
static	Mt	mats[4][V][H];	// psf is modified
#endif

dbt inp[EY][EX];// input degraded
dbt est[EY][EX];// estimate
#ifdef BEST
dbt est0[EY][EX];// estimate
#endif
dbt flt[PY][PX];// filtered and clipped or error
dbt err[PY][PX];// error
dbt rat[PY][PX];// rate error
dbt tmp[PY][PX];// tmporal
char name[256]="init";

// for FFT
static complex	wk[Fs][Fs];	// fft buffer
static complex	wkt[Fs][Fs];	// fft buffer
static double	matrix[N][N*2];
int xoff,yoff;

//----------------------initial PSF's------------------------------------------
#ifdef HALF
#define TH 0
int cx=  8; int cy= 8;
int ix= -2; int ax= 4;
int iy= -7; int ay= 6;
static Uc mat[V*H]={ // half
  0,0,0,0, 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,0,0,
  0,0,0,0, 0,  0,  0,  0,  0,  0, 53, 67,  0,  0,0,0,
  0,0,0,0, 0,  0,  0,  0,  0,  0, 99,139, 73,  0,0,0,
  0,0,0,0, 0,  0,  0,  0,  0, 49,163,185, 63,  0,0,0,
  0,0,0,0, 0,  0,  0,  0,  0, 97,191,147, 27,  0,0,0,
  0,0,0,0, 0,  0,  0,  0, 54,134,176, 74,  0,  0,0,0,
  0,0,0,0, 0,  0, 23, 41, 92,151,111, 39,  0,  0,0,0,
  0,0,0,0, 0,  0, 10, 85,140,153, 62,  5,  0,  0,0,0,
  0,0,0,0, 0,  0, 21,122,180,156, 31,  0,  0,  0,0,0,
  0,0,0,0, 0,  0, 26,103,173,151, 33,  0,  0,  0,0,0,
  0,0,0,0, 0,  0, 25, 70,159,151, 37, 10,  0,  0,0,0,
  0,0,0,0, 0,  0,  0, 75,164,152, 31,  2,  0,  0,0,0,
  0,0,0,0, 0,  0,  0, 72,126,111, 20,  6,  0,  0,0,0,
  0,0,0,0, 0,  0,  0, 36, 52, 45,  8,  0,  0,  0,0,0,
  0,0,0,0, 0,  0,  0,  0, 16, 15, 11,  0,  0,  0,0,0,
  0,0,0,0, 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,0,0,
};
#endif
//----------------------initial PSF's------------------------------------------
#ifdef YASUK
#define TH 14
int cx=  7; int cy=  9;
int ix= -3; int ax=  5;
int iy= -7; int ay=  5;
static Uc mat[V*H]={
  14,14,14,14,14,14, 14, 14, 56, 22, 29, 34, 21, 21, 22, 24,
  14,14,14,14,14,14, 14, 76, 47, 31, 35, 35, 20, 14, 19, 21,
  14,14,14,14,14,14, 85, 57, 39, 53, 69, 55, 20, 12, 19, 19,
  14,14,14,14,14,14, 14, 34, 36,103,136, 72,  9, 11, 17, 16,
  14,14,14,14,14,14, 20, 21, 51,168,186, 63,  2, 10, 14, 14,
  14,14,14,14,14,14, 28, 38, 87,184,147, 26,  2, 10, 13, 14,
  14,14,14,14,14,14, 28, 64,133,171, 83,  7,  4, 12, 14, 15,
  14,14,14,14,14,20, 42, 87,156,113, 30,  4,  5, 14, 11, 12,
  14,14,14,14,11,17, 84,137,148, 63,  8,  3, 11, 13, 13, 13,
  14,14,14,14, 5,22,126,188,153, 33,  3,  5, 15, 15, 15, 13,
  14,14,14,14,10,27,101,170,150, 28,  3,  7, 13, 15, 15, 13,
  14,14,14,14,17,23, 75,156,157, 34,  2, 12, 18, 13, 13, 13,
  14,14,14,14,22,21, 75,168,161, 35,  1,  9, 16, 15, 13, 14,
  14,14,14,14,28,33, 67,126,102, 18,  9, 15, 14, 12, 13, 14,
  14,14,14,14,23,34, 43, 57, 40, 14, 15, 14, 13, 12, 13, 14,
  14,14,14,14,25,28, 19, 12, 13, 14, 14, 14, 15, 14, 15, 14,
};
#endif
//----------------------initial PSF's------------------------------------------
#ifdef FLAT
int cx= M; int cy= U;
int ix=-M; int ax= M-1;
int iy=-U; int ay= U-1;
/* for mid
int ix=-2; int ax= 2;
int iy=-3; int ay= 3;
*/
#define TH 0
static Uc mat[V*H];
#endif
//----------------------initial PSF's------------------------------------------
#ifdef PSF2
#define TH 60
int ix= -4; int ax=  2;
int iy= -7; int ay=  5;
int cx=  8; int cy=  8;

static	Uc	mat[V*H]= {	// h() 1-d impulse response
 58, 55, 57, 56, 56, 62, 66, 91, 95, 81, 54, 38, 42, 52, 51, 52,
 58, 58, 55, 54, 52, 66,110,197,240,238,141, 51, 41, 52, 53, 51,
 56, 56, 54, 53, 50, 70,137,230,254,254,197, 45, 29, 53, 52, 53,
 55, 54, 55, 52, 49, 70,142,234,252,252,157, 23, 27, 50, 56, 52,
 55, 54, 61, 57, 48, 64,147,240,252,249,119, 20, 26, 41, 52, 51,
 56, 54, 57, 64, 63, 63,146,243,251,246, 90, 19, 34, 47, 50, 54,
 56, 56, 57, 66, 89,117,191,250,250,182, 48, 15, 35, 48, 53, 53,
 63, 59, 55, 67,111,206,251,253,254,126, 17, 19, 37, 47, 50, 53,
 60, 59, 61, 55,104,219,253,254,255,141, 23, 23, 42, 53, 57, 54,
 58, 63, 58, 49, 71,141,248,253,252,184, 44, 28, 46, 55, 53, 52,
 60, 62, 59, 56, 53, 90,192,252,253,244, 88, 32, 43, 46, 51, 52,
 56, 60, 57, 61, 52, 58,146,242,252,250,125, 31, 39, 44, 48, 55,
 61, 57, 52, 58, 52, 41, 91,206,253,250,104, 30, 39, 52, 52, 54,
 58, 57, 53, 59, 54, 42, 61,126,172,120, 45, 31, 47, 54, 55, 56,
 59, 60, 58, 57, 51, 43, 50, 64, 62, 39, 26, 40, 51, 52, 54, 57,
 59, 59, 57, 56, 50, 41, 43, 48, 50, 41, 39, 48, 54, 54, 53, 56,
};
#endif
//----------------------initial PSF's------------------------------------------
#ifdef PSF3
#define TH 0
int cx=  6; int cy=  5;
int ix= -2; int ax=  1;
int iy= -3; int ay=  5;
static	Uc	mat[V*H]= {	// h() 1-d impulse response
 57, 59, 63, 72, 68, 60, 57, 48, 27, 44,115,188,228,244,247,252,
 63, 59, 63, 71, 65, 58, 61, 51, 27, 42,116,188,222,229,225,238,
 83, 61, 61, 63, 61, 66, 77, 56, 21, 39,107,180,219,223,208,211,
 89, 69, 60, 54, 60, 85,107, 74, 26, 32, 95,170,214,216,194,188,
 97, 70, 57, 50, 59,111,153, 97, 31, 26, 80,157,205,212,181,168,
100, 61, 52, 45, 65,132,176,109, 28, 19, 59,139,193,201,173,145,
 97, 61, 45, 43, 73,127,155, 95, 23, 12, 58,140,189,193,172,140,
 97, 60, 36, 46, 95,137,139, 81, 24, 12, 56,133,181,192,170,143,
101, 62, 43, 43, 83,139,161,105, 34, 17, 47,118,164,182,163,143,
 99, 66, 51, 43, 61,114,161,123, 45, 20, 33, 98,138,156,148,134,
 88, 63, 48, 47, 50, 75,114,101, 51, 30, 36, 79,116,132,129,123,
 76, 53, 57, 64, 54, 59, 86, 78, 46, 43, 61, 80,100,109,109,110,
 72, 54, 78,100, 60, 45, 69, 68, 43, 59, 89, 86, 91, 96, 95, 98,
 79, 65, 84,113, 72, 53, 67, 63, 45, 66, 98, 88, 88, 94, 87, 87,
 83, 77, 84, 94, 70, 66, 70, 63, 50, 68, 87, 81, 86, 90, 86, 92,
 77, 81, 89, 82, 67, 65, 67, 62, 61, 79, 85, 81, 88, 87, 85, 96,
};
#endif

//---- gamma(power of 2.22)  and inverse gamma (power of 0.45)------------------
dbt
gamma(dbt v){	// ~ pow(x/255,2.222)
	v/= 255.;
	if(v<0.) v= 0.; if(v>1.) v= 1.;
	if(use_gamma){
		if(v<.081) v/= 4.5;
		else v= pow((v+.099)/1.099,1/.45);
	}
	if(v<0.) v= 0.; if(v>1.) v= 1.;
	return v;
}
int
igamma(dbt v){	// ~ pow(x,0.45)*255
	int i;
	if(v<0.) v= 0.; if(v>1.) v= 1.;
	if(use_gamma){
		if(v<.018) v*= 4.5;
		else v= 1.099*pow(v,.45)-.099;
	}
	v*= 255.;
	if(use_expand) v= (v-16)*255/(235-16);//16-235=>0-255(ITU-R601 luma)
	i= v+.5;
	if(i<0)i= 0; if(i>255)i= 255;
	return i;
}
//----------------------- print array ------------------------------------------
void
pr_mat(Mt m[V][H]) {
	int i,j;
	for(j=0;j<V;j++){
		//for(i=0;i<H;i++) printf("%4d ",(int)(m[j][i]*V*H*100+.5));
		for(i=0;i<H;i++) printf("%1d ",(int)(m[j][i]*V*H));
		printf("\n");
	}
	printf("\n");
}

//----------------------- small array funcs ------------------------------------
//-- small array functions
void clr(Mt a[V][H]) { int i,j; for(j=0;j<V;j++) for(i=0;i<H;i++) a[j][i]= 0; }
void no_minus(Mt a[V][H]) { int i,j; for(j=0;j<V;j++) for(i=0;i<H;i++) if(a[j][i]<0) a[j][i]= 0; }
void plus(Mt a[V][H]) { int i,j; for(j=0;j<V;j++) for(i=0;i<H;i++) a[j][i]= fabs(a[j][i]); }
void sqr(Mt a[V][H]) { int i,j; for(j=0;j<V;j++) for(i=0;i<H;i++) a[j][i]= sqrt(a[j][i]); }
void mls(Mt a[V][H],Mt b) { int i,j; for(j=0;j<V;j++) for(i=0;i<H;i++) a[j][i]*= b; }
void add(Mt a[V][H],Mt b[V][H]) { int i,j; for(j=0;j<V;j++) for(i=0;i<H;i++) a[j][i]+= b[j][i]; }
void sub(Mt a[V][H],Mt b[V][H]) { int i,j; for(j=0;j<V;j++) for(i=0;i<H;i++) a[j][i]-= b[j][i]; }
void mlt(Mt a[V][H],Mt b[V][H]) { int i,j; for(j=0;j<V;j++) for(i=0;i<H;i++) a[j][i]*= b[j][i]; }
void cpy(Mt a[V][H],Mt b[V][H]) { int i,j; for(j=0;j<V;j++) for(i=0;i<H;i++) a[j][i]=  b[j][i]; }
void subs(Mt a[V][H],int c) { int i,j; for(j=0;j<V;j++) for(i=0;i<H;i++) { a[j][i]-= c; if(a[j][i]<0)a[j][i]= 0;} }
void avg(Mt a[V][H],Mt b[V][H]) { int i,j; for(j=0;j<V;j++) for(i=0;i<H;i++) a[j][i]= (a[j][i]+b[j][i])/2; }
dbt  sum(Mt a[V][H]) { int i,j; dbt s= 0; for(j=0;j<V;j++) for(i=0;i<H;i++) s+= a[j][i]; }

//---------------- between Sif image and dbt image array -----------------------
// Sif (upleft (sx,sy) to (ex-1,ey-1)) ==> dbt array
void
sif2dbl(rect *r, Sif *p,dbt b[PY][PX])
{
	int i,j;
	for(j=r->s.y;j<r->e.y;j++)
	for(i=r->s.x;i<r->e.x;i++) b[j-r->s.y][i-r->s.x]= gamma((dbt)p->y[j][i]);
}
#ifdef GE
void
sif2g_est(Sif *p, dbt b[SY][SX])	// copy whole sif to double type image
{
	int i,j;
	for(j=0;j<SY;j++)
	for(i=0;i<SX;i++) b[j][i]= gamma((dbt)p->y[j][i]);
}
// ===> back to Sif(sx,sy)-(ex-1,ey-1)
void
dbl2sif(rect *ir, rect *or, dbt b[SY][SX], Sif *p) // copy back selected area
{
	int i,j,dx,dy;
	dx= or->s.x - ir->s.x;
	dy= or->s.y - ir->s.y;
	for(j=or->s.y;j<or->e.y;j++)
	for(i=or->s.x;i<or->e.x;i++) p->y[j][i]= igamma(b[j][i]);
}
#else
void
dbl2sif(rect *ir, rect *or, dbt b[PY][PX], Sif *p)
{
	int i,j,dx,dy;
	dx= or->s.x - ir->s.x;
	dy= or->s.y - ir->s.y;
	for(j=0;j<or->e.y - or->s.y;j++)
	for(i=0;i<or->e.x - or->s.x;i++) p->y[j+ or->s.y][i+ or->s.x]= igamma(b[j+dy][i+dx]);
}
#endif

#ifdef IIR_INV2
//------ normalize (only from ix to ax, from iy to ay)-----------------
int
norm1(Mt m[V][H], double c) // normalize sum of mat to be 1.
{
	int i,j; double sum= 0;
	for(j=iy;j<=ay;j++)
	for(i=ix;i<=ax;i++) sum+= m[j+U][i+M];
	sum/= c; //printf("normalize sum:%f to %f\n",sum,c);
	if(sum==0.) return 1;
	for(j=iy;j<=ay;j++)
	for(i=ix;i<=ax;i++) m[j+U][i+M]/= sum;
	return 0;
}
void
div1(Mt m[V][H], double c) // divide by c
{
	int i,j;
	for(j=iy;j<=ay;j++)
	for(i=ix;i<=ax;i++) m[j+U][i+M]/= c;
}

Mt m1[V][H];
Mt last_err;
Mt lastm[V][H];

//----------------------- make error ------------------------------------------
void
mk_err(rect *or, rect *of, Mt psf[V][H]) // filter estimate by psf
{
	int i,j,k,l,c=0;
	int sx= or->s.x; int dx= or->e.x - sx;	// used as pos
	int sy= or->s.y; int dy= or->e.y - sy;	// by es(),in()
	Mt s= 0;

lo:
	for(j=of->s.y;j<of->e.y;j++)
	for(i=of->s.x;i<of->e.x;i++) {	// flt, err, rat area
		dbt a= 0;
		for(l= iy;l<=ay;l++)
		for(k= ix;k<=ax;k++) a+= es(j-l,i-k) * psf[l+U][k+M];
		if(a< 0.001) a= 0.001; if(a> 1.) a= 1.;
		flt[j][i]= a;
		err[j][i]= in(j,i)-a;
		rat[j][i]= in(j,i)/a;
		s+= err[j][i] * err[j][i];
		c++;
	}
	s/= c;

	if(last_err!=0 && s>last_err) { cpy(psf,lastm); goto lo; }
	else { last_err= s; cpy(lastm,psf); }
	printf(" %f\n",sqrt(s));
}

//---------------------------make estimate image -------------------------------
void
mk_est(rect *or, rect *ir, Mt psf[V][H]) // modify estimate
{
	int i,j,k,l,x1,x2,y1,y2,v; dbt a,e;
	int sx= or->s.x; int dx= or->e.x - sx;	// used as pos of est
	int sy= or->s.y; int dy= or->e.y - sy;
	Mt b[V][H];

	if(psfm==2) clr(m1);
#ifdef BEST
	memcpy(est0,est,sizeof(est));// to separate est before modified
#endif
	
	if(estm==0) { // alg0
	for(j=ir->s.y;j<ir->e.y;j++)
	for(i=ir->s.x;i<ir->e.x;i++) {
		a= err[j][i];
		for(l= iy;l<=ay;l++)	// deliver err to est
		for(k= ix;k<=ax;k++) es(j-l,i-k) += a * psf[l+U][k+M];
	}
	} else	if(estm==1) { // alg1
	for(j=ir->s.y;j<ir->e.y;j++)
	for(i=ir->s.x;i<ir->e.x;i++) {
		a= 0;
		for(l= iy;l<=ay;l++)
		for(k= ix;k<=ax;k++) a+= b[l+U][k+M]= best(j-l,i-k)*psf[l+U][k+M];

		//if(a< 0.001) a= 0.001; if(a> 1.) a= 1.;
		a= err[j][i]/a;
		//a= err[j][i]/flt[j][i];

		for(l= iy;l<=ay;l++)
		for(k= ix;k<=ax;k++) {
			e= a*b[l+U][k+M];
			es(j-l,i-k)+= e;
			if(psfm==2) m1[l+U][k+M]+= e;
		}
	}
	} else if(estm==2) { // lucy
	for(j=0;j<dy;j++)
	for(i=0;i<dx;i++) {
		a= 0; if(psfm==2) e= es(j,i);
		for(l= iy;l<=ay;l++)
		for(k= ix;k<=ax;k++) {
			if(j+l>=U && j+l<dy-U && i+k>=M && i+k<dx-M) {
			a+= rat[j+l][i+k] * psf[l+U][k+M];
			if(psfm==2) m1[l+U][k+M]+= e*(rat[j+l][i+k]-1)* psf[l+U][k+M];
			} else a+= psf[l+U][k+M];
		}
		es(j,i)*= a;
	}
	}
	for(j=0;j<dy;j++)
	for(i=0;i<dx;i++) if(es(j,i)<0) es(j,i)= 0;
}

//----------------------- centroid of psf --------------------------------------
int
centroid(int sx, int sy, int dx, int dy, Mt m[V][H])
{
	int i,j,x,y; Mt cx=0,cy=0; Mt t[V][H];

	for(j=0;j<V;j++)
	for(i=0;i<H;i++) { Mt d= m[j][i]; cx+= d*(i-M); cy+= d*(j-U); }
	//printf("centroid=(%4.2f,%4.2f)\n",cx,cy);
	if(cx<0)x= cx-.5;
	else    x= cx+.5;
	if(cy<0)y= cy-.5;
	else    y= cy+.5;
	//x= cx; y= cy;

	if(x|y){
		cpy(t,m); //memcpy(tmp,est,sizeof(est));
		if(y>=0)
		for(j=0;j<V-y;j++) {
			if(x>=0) for(i=0;i<H-x;i++) m[j][i]= t[j+y][i+x];
			else	 for(i=-x;i<H;i++)  m[j][i]= t[j+y][i+x];
		}
		else for(j=-y;j<V;j++) {
			if(x>=0) for(i=0;i<H-x;i++) m[j][i]= t[j+y][i+x];
			else	 for(i=-x;i<H;i++)  m[j][i]= t[j+y][i+x];
		}
		/*
		if(y>=0)
		for(j=0;j<dy-y;j++) {
			if(x>=0) for(i=0;i<dx-x;i++) es(j+y,i+x)= tmp[j][i];
			else	 for(i=-x;i<dx;i++)  es(j+y,i+x)= tmp[j][i];
		}
		else for(j=-y;j<dy;j++) {
			if(x>=0) for(i=0;i<dx-x;i++) es(j+y,i+x)= tmp[j][i];
			else	 for(i=-x;i<dx;i++)  es(j+y,i+x)= tmp[j][i];
		}
		*/
		//if( norm1(m,(double)1.)) return 1; 
		printf("moved\n");
	}
	return 0;
}

void
show_psf(Mt m[V][H])
{
	int k,l;
	for(l=iy;l<=ay;l++)
	for(k=ix;k<=ax;k++) {
dbt d= m[l+U][k+M]*256*50; if(d<0)d=0; if(d>255)d= 255; est[l+U][k+M]= gamma(d);
	}
}

//----------------- move psf ---------(estimate psf)----------------------------
int
move_psf(rect *or, rect *of, Mt m[V][H])
{
	int i,j,k,l;
	int sx= or->s.x; int dx= or->e.x - sx;
	int sy= or->s.y; int dy= or->e.y - sy;
	Mt e= 0;
	Mt th= 0.0;

	if(psfm==2){

	for(j=0;j<PY;j++)
	for(i=0;i<PX;i++) e+= best(j,i);
	mls(m,e/accl);
	add(m,m1);

	} else {

	for(l=iy;l<=ay;l++)
	for(k=ix;k<=ax;k++) {
		dbt a= 0;
		for(j=of->s.y;j<of->e.y;j++)
		for(i=of->s.x;i<of->e.x;i++){
#ifdef RECALC
			dbt b= es(j-l,i-k);
#else
			dbt b= best(j-l,i-k);
#endif
			if(psfm==1) e= rat[j][i];
			else e= err[j][i];

			if(accl==1){ if(e>th) a+= (e-th) * b; }
			else if(e>0){
				if(accl==2) e= e*e;
				else if(accl==3) e= e*e*e;
				else if(accl==4) e= e*e*e*e;
				else if(accl==5) e= e*e*e*e*e;
				else if(accl==6) e= e*e*e*e*e*e;
				a+= e * b;
			}
		}
		m1[l+U][k+M]= a;
	}
	if(psfm==3) sqr(m1);
	if(sum(m1)) mlt(m,m1);
	else printf("m1 is all 0\n");
	no_minus(m);

	}
	//centroid(sx,sy,dx,dy,m);
	if(norm1(m,(double)1.)) return 1;
	//show_psf(m);
	//pr_mat(m);
	return 0;
}

//--------- direction preserve filter ------------------------------
void
dfilter(int th)
{
	int i,j,k,l;
	Mt ul,uc,ur,cl,cc,cr,dl,dc,dr,hd,vd,rd,ld,min,res;
	for(j=1;j<PY-1;j++)
		for(i=1;i<PX-1;i++) {
			ul= est[j-1][i-1];
			uc= est[j-1][i];
			ur= est[j-1][i+1];
			cl= est[j  ][i-1];
			cc= est[j  ][i];
			cr= est[j  ][i+1];
			dl= est[j+1][i-1];
			dc= est[j+1][i];
			dr= est[j+1][i+1];
			hd= fabs(cl+cr-2*cc);
			vd= fabs(uc+dc-2*cc);
			rd= fabs(dl+ur-2*cc);
			ld= fabs(dr+ul-2*cc);
			min= th; res= cc;
			if(hd<min) {min= hd; res= (cl+cr+2*cc)/4; }
			if(vd<min) {min= vd; res= (uc+dc+2*cc)/4; }
			if(rd<min) {min= rd; res= (dl+ur+2*cc)/4; }
			if(ld<min) {min= ld; res= (dr+ul+2*cc)/4; }
			flt[j][i]= res;
		}
	memcpy(est,flt,sizeof(est));
}

//-----------------epsilon filter------------------------------
void
efilter(int th)
{
	int i,j,k,l,cnt;
	Mt c,d,sum;
	for(j=1;j<PY-1;j++)
		for(i=1;i<PX-1;i++) {
			c= est[j][i];
			sum= c;
			cnt= 1;
			for(l=-1;l<=1;l++)
			for(k=-1;k<=1;k++){
				d= est[j+l][i+k];
				if(fabs(d-c)<= th){ sum+= d; cnt++; }
			}
			flt[j][i]= sum/cnt;
		}
	memcpy(est,flt,sizeof(est));
}

void
init_pic(int val, Mt p[PY][PX]){
	int i,j;
	for(j=0;j<PY;j++)
	for(i=0;i<PX;i++) p[j][i]= val;
}

void
loop_filter(int th)
{
	//dfilter(1);
	efilter(th);
}
void
post_filter(int th)
{
	//dfilter(th);
	efilter(th);
}

void
write_out_psf_jpg(int lp, char *n, Mt m[V][H])
{
	write_out(sizeof(Sif),"o.yuv");
	//sprintf(n,"%d.psf",lp); write_psf(n, m);
	sprintf(n,"convert -size %dx%d o.yuv out%d.jpg",SX,SY,lp); system(n);
}

/*
**	iterational inverse filter (IIR2)
*/
int
iir2(int o,int i,int j,rect *or,rect *ir,rect *of,Mt m[V][H])
{	
	int lp;
	if(norm1(m,(double)1.))return 1;
#ifndef GE
	sif2dbl(or,&in,inp);
	memcpy(est,inp,sizeof(inp));
	//init_pic(gamma((dbt)40.),est);
#endif
	for(lp= 0;lp<iloop;lp++){
		if(pr)printf("lp= %d\t",lp);
		mk_err(or,of,m);
		mk_est(or,of,m);
#ifdef RECALC
		mk_err(or,of,m);
#endif
		if(move_psf(or,of,m)) break;
		//loop_filter(1);
		dbl2sif(or,ir,est,&ot);
		sprintf(name,"o=%d (y=%d,x=%d,it=%4d)", o, j, i, lp);
		wt(&ot,name); // display on X-window
		//if(lp%100==0)write_out_psf_jpg(lp, name, m);
	}
	//post_filter(1); dbl2sif(or,ir,est,&ot);
	//write_out_psf_jpg(lp, name, m);
	return 0;
}
#endif
//---
void
norm(Mt m[V][H], double c) // normalize sum of mat to be 1.
{
	int i,j; double sum= 0;
	for(j=0;j<V;j++) for(i=0;i<H;i++) sum+= m[j][i];
	sum/= c; //printf("normalize by:%f\n",sum);
	for(j=0;j<V;j++) for(i=0;i<H;i++) m[j][i]/= sum;
}

/*
**	inv_mat(): inverse matrix
**	input: set square (n x n) matrix left half, and unit matrix right half.
**	output: unit made on left side, inverse matrix is made right side.
**	note: use double as matrix element type, index i,j of aji bji are 0 to n-1.
*/
void
inv_mat(int n, int m)	// inverse matrix (n x n), use m x n matrix (m= 2n)
{
	int i,j,k; double a;
	for(k=   0; k<n; k++)
	for(j= k+1; j<n; j++) { a= matrix[j][k]/matrix[k][k]; for(i=k;i<m;i++) matrix[j][i]-= matrix[k][i]*a; }
	for(j=   0; j<n; j++) { a= 1./matrix[j][j]; for(i=j;i<m;i++) matrix[j][i]*= a; }
	for(k= n-1;k>=0; k--)
	for(j= k-1;j>=0; j--) { a= matrix[j][k]; for(i=k;i<m;i++) matrix[j][i]-= matrix[k][i]*a; }
}


/*
**	put_mat: put mat[V][H] to matrix[N][N] (N= P*P (P= H)),
**	matrix[j][i]= mat[y][x] when (-M <=y[i]-y[j]< M && -M<=x[i]-x[j]< M)
**	and make unit-matrix on the right half of the matrix (i: column, j: raw)
*/
void
put_mat(Mt m[V][H])
{
	int i,j;
	for(j=0;j<N;j++)
	for(i=0;i<N;i++) {
		int dy= (i/P)-(j/P);
		int dx= (i%P)-(j%P);
		if(dy<U && dy>=-U && dx<M && dx>=-M) matrix[j][i]= m[dy+U][dx+M];
		matrix[j][i+N]= (i==j);
	}
}

#define Center (M*H+M)
#define skip_center(i) (i+(i>=Center))
void
put_mat_sk(Mt m[V][H])
{
	int i,j;
	for(j=0;j<N-1;j++) {
		int j1= skip_center(j);
	for(i=0;i<N-1;i++) {
		int i1= skip_center(i);
		int dy= (i1/P)-(j1/P);
		int dx= (i1%P)-(j1%P);
		if(dy<U && dy>=-U && dx<M && dx>=-M) matrix[j][i]= m[dy+U][dx+M];
		matrix[j][i+N]= (i==j);
	}}
}

#define CN ((P+1)*P/2)
#define CM (M*P+M)
void
get_mat(Mt m[V][H],int x, int y)	//	get center pel raw
{
	int i,j;
	int off= y*P+x;
	for(j=0;j<V;j++) for(i=0;i<H;i++) m[j][i]= matrix[CN+off][CN+off+j*P+i-CM+N];
}

void
fft(complex *x,int n,int f)	// 2's power FFT
{
	int	mm,m,j,i;
	complex t,wp,w;
	for (j= i= 0; i< n; i++) { // bit reversal replacement
		if (j>i) { t= x[j]; x[j]= x[i]; x[i]= t; }	// exchange x[i],x[j]
		m= n>>1;
		while (m>=2 && j>=m) { j-= m; m>>= 1; }		// revsl-increment j
		j+= m;
	}
	wp.re= -1; wp.im=  0;	// initial wp= exp(-j pai)
	for (mm=1; mm< n; mm<<=1) {
		w.re= 1; w.im= 0;
		for (m=0; m<mm; m++) {
			j= m+mm;
			for (i= m; i< n; i+= mm*2, j+= mm*2) {
				t.re= w.re * x[j].re - w.im * x[j].im;// rotate x[j] by w
				t.im= w.re * x[j].im + w.im * x[j].re;// add and subtr
				x[j].re= x[i].re - t.re; x[j].im= x[i].im - t.im;
				x[i].re= x[i].re + t.re; x[i].im= x[i].im + t.im;
			}
			t= w;	// rotate w by wp
			w.re= t.re*wp.re - w.im*wp.im;
			w.im= t.re*wp.im + w.im*wp.re;
		}
		wp.im= sqrt(.5-wp.re*.5)*f;			// halve argment of wp
		wp.re= sqrt(.5+wp.re*.5);			// f= -1: fft, 1: ifft
	}
}

void
fft2(int nn,int f) { fft(&wk[0][0],nn*nn,f); }
/* No need to use 2-dimensional fft, we get exactly same result !
void
fft2(int nn,int f)
{
	int i,j;
	for(j=0;j<Fs;j++) fft(wk[j],nn,f);
	for(j=0;j<Fs;j++)
	for(i=0;i<Fs;i++) wkt[i][j]= wk[j][i];
	for(j=0;j<Fs;j++) fft(wkt[j],nn,f);
	for(j=0;j<Fs;j++)
	for(i=0;i<Fs;i++) wk[i][j]= wkt[j][i];
}
*/
void prep_fft(Mt m[V][H]) { int i,j; for(j=0;j<V;j++) for(i=0;i<H;i++) wk[j][i].re= m[j][i]; }
void prep_fir(Mt m[V][H]) { int i,j; for(j=0;j<V;j++) for(i=0;i<H;i++) m[j][i]= wk[j][i].re; }
void
mk_mat4()	// high pass filter
{
	int i,j;
	Mt sum= 0;
	for(j=0;j<V;j++) for(i=0;i<H;i++) sum+= mat4[j][i]= 1./((i-M)*(i-M)+(j-U)*(j-U)+2.);
	for(j=0;j<V;j++) for(i=0;i<H;i++) mat4[j][i]/= -sum;
	mat4[U][M]+= 2.0;
}
void
pr_freq(void)
{
	int i,j;
	for(j=0;j<Fs;j++){ printf("\n"); for(i=0;i<Fs;i++) printf("%5.2f ",wk[j][i].re); } printf("\n");
	for(j=0;j<Fs;j++){ printf("\n"); for(i=0;i<Fs;i++) printf("%5.2f ",wk[j][i].im); } printf("\n");
}
void
wiener(void)
{
	int i,j;
	double m,r,p;
	for(j=0;j<Fs;j++)
	for(i=0;i<Fs;i++){
		r= wk[j][i].re;
		m= wk[j][i].im;
		//p= r*r + m*m + 0.93;// 1.: noise
		p= r*r + m*m; if(p<1) p= 1;
		wk[j][i].re/=  p;
		wk[i][i].im/= -p;
	}
}
void
root(void)
{
	int i,j;
	double m,r;
	for(j=0;j<Fs;j++)
	for(i=0;i<Fs;i++){
		r= wk[j][i].re;
		m= wk[j][i].im;
		if(r<0) wk[j][i].re= -sqrt(-r);
		else	wk[j][i].re= sqrt(r);
		if(m<0) wk[i][i].im= -sqrt(-m);
		else	wk[i][i].im= sqrt(m);
	}
}


void
auto_correlation(Mt m[V][H])	// calculate auto correlation function
{
	int i,j,k,l,d;
	double c;
	for(l=0;l<V;l++)
	for(k=0;k<H;k++) {
		double s= 0;
		for(j=U;j<PY-U;j++)
		for(i=M;i<PX-M;i++) s+= in.y[j][i] * in.y[j+l-U][i+k-M];
		m[l][k]= s;
	}
	c= m[U][M];
	for(l=0;l<V;l++)
	for(k=0;k<H;k++) m[l][k]/= c;
}

void
mk_psf2(Mt m[V][H])	// make point spreading function by calc auto_corr and squared
{
	auto_correlation(m);
	mlt(m,m);
	norm1(m,(double)1);
	pr_mat(m);
}
void
mk_psf(Mt m[V][H])	// make point spreading function by calc auto_corr, and root spectrum
{
	auto_correlation(m);
	norm1(m,(double)1);
	pr_mat(m);
	prep_fft(m);
	fft2(Fs,-1);
	root();
	fft2(Fs, 1);
	prep_fir(m);
	norm1(m,(double)1);
	pr_mat(m);
}

void
peak_pos(int x0, int y0, int *px, int*py, int *pk)
{
	int x,y;
	int max= 160;
	for(y= y0;y<y0+V;y++)
	for(x= x0;x<x0+H;x++) { int d= in.y[y][x]; if(d>max) { max= d; *px= x; *py= y; *pk= max; } }
}

void
get_rect(int x0, int y0, Mt m[V][H], Sif *p)
{
	int x,y;
	for(y= y0-U;y<y0+U;y++)
	for(x= x0-M;x<x0+M;x++) m[y-y0+M][x-x0+M]= p->y[y][x];
}

double
average(Mt m[V][H])
{
	int i,j, sum= 0;

	for(j=0;j<V;j++)
	for(i=0;i<H;i++) sum+= m[j][i];	
	return (double)sum/(V*H);
}

void
draw_line(int x, int y)
{
	int i,j;
	for(i=x-8;i<x+8;i++) in.y[y][i]= 255;
}
void
draw_line2(int x, int y)
{
	int i,j;
	for(i=y-8;i<y+8;i++) in.y[i][x]= 255;
}


int
area(Mt m[V][H])
{
	int i,j,a=0;
	for(j=0;j<V;j++)
	for(i=0;i<H;i++) a+= (m[j][i]!=0);
	//printf("%d\n",a);
	return a;
}

int
c1(int i, int j, Mt m[V][H], Mt n[V][H],Mt c, Mt last)
{
	int sum= 0;
	while (i>=0 && i<H && j>=0 && j<V && n[j][i]>=c && n[j][i]<=last+8 && m[j][i]==0){
		last= m[j][i]= n[j][i];
		sum++;
		sum+= c1(i+1,j,m,n,c,last);
		sum+= c1(i,j+1,m,n,c,last);
		sum+= c1(i-1,j,m,n,c,last);
		sum+= c1(i,j-1,m,n,c,last);
	}
	return sum;
}

int
connect1(Mt m[V][H], Mt c)
{
	Mt n[V][H];
	int i,j, r;

	for(j=0;j<V;j++)
	for(i=0;i<H;i++) n[j][i]= m[j][i];

	for(j=0;j<V;j++)
	for(i=0;i<H;i++) m[j][i]= 0;

	r= c1(M,M,m,n,c,255);
	return r;
}

void
get_peak(int sx, int sy, Mt m1[V][H], Sif *p)
{
	int i,j,x,y,pk,min=100,t;
	Mt m[V][H];
	Mt c;

	/*
	for(j=V;j<sy-V;j+=V)
	for(i=H;i<sx-H;i+=H) {
		x= y= 0;
		peak_pos(i,j, &x, &y, &pk);
		if((x|y) //&&((p->y[y][x] + p->y[y][x+1] + p->y[y+1][x] + p->y[y+1][x+1] )/4>= 150)
				){
			get_rect(x,y,m,p);
			if((c=average(m))<pk/2) {
				printf("pk(%d %d)pk=%d c=%3.1f ",x,y,pk,c);
				//draw_line(x,y);
				connect1(m,c);
				norm(m,(double)1.);
				pr_mat(m);
				t= area(m);
				if(t<min) {
					min= t; printf("min= %d at(%d %d)\n",min,x,y);
					//draw_line2(x,y);
					cpy(m1,m);
				}
			}
		}
	}
	*/
	strcpy(name,"point");
loop:
	peak_pos_x= peak_pos_y= 0;
	while((x=peak_pos_x)==0 || (y=peak_pos_y)==0){ usleep(100000); wt(&in,name); }
	get_rect(x,y,m,p);
	c= average(m);
	printf("(%d %d) c=%3.1f\n",x,y,c);
	t= connect1(m,c);
	if(t==0) { strcpy(name,"psf is not defined."); goto loop; }
	norm(m,(double)1.);
	pr_mat(m);
	t= area(m);
	if(t<5) { strcpy(name,"too small area, re-point."); goto loop; }
	cpy(m1,m);
}

void
prep_psf(int c, Mt m[V][H],int sx, int sy)	// prepare point spreading function
{
	int i,j,k,l;

	if(c!=2)
	for(j=iy;j<=ay;j++)
	for(i=ix;i<=ax;i++) {
		dbt d= mat[(j+cy)*H+(i+cx)] - TH;
		if (d<0) d= 0;
		d= gamma(d);
		m[j+U][i+M]= d;
	}
	norm1(m,(double)1);
	//mk_psf2(m);
	//get_peak(sx,sy, m, &in);
#ifdef VSEP
	for(k=0;k<4;k++) {
		for(j=0;j<V;j++)
		for(i=0;i<H;i++) mats[k][U+(j-U)*(5-k)/5][i]+= m[j][i];
		norm(mats[k],(double)1);
	}
#endif
}

/*
**	iir() : IIR inverse filtering
**	 input: p1: degraded, p2: iteration n-1, m: point spread function
**	output: p3: iteration n
*/
void
iir(int sx,int sy, Sif *p1, Sif *p2, Sif *p3, Mt m[V][H])
{
	int i,j,k,l,x1,x2,y1,y2,v;
	double center= -m[V][M]+FP+1.;

	for(j=0;j<sy;j++)
	for(i=0;i<sx;i++){
		double a= center * p1->y[j][i] + 0.5; // center pel is from p1

		x1= -M; if(i+x1< 0) x1= -i;
		x2=  M-1; if(i+x2>sx) x2= sx-i;
		y1= -U; if(j+y1< 0) y1= -j;
		y2=  U-1; if(j+y2>sy) y2= sy-j;	// surrounding area is constranied

		for(l= y1;l<y2;l++)
		for(k= x1;k<x2;k++) if(k|l) a-= p2->y[j-l][i-k] * m[l+U][k+M];

						// from p2 and mat2[][]

		v= a; if(v<0) v= 0; else if(v>255) v= 255; // limit in [0,255]
		p3->y[j][i]= v;
	}
}
void
iir1(int sx,int sy, Mt m[V][H])
{
	int i,j,k,l;
	double center= m[U][M]+FP1+1.;
	for(j=-iy;j<sy-ay;j++)
	for(i=-ix;i<sx-ax;i++){
		dbt a= 0;
		//dbt a= center * inp[j][i]; // center pel is from inp
		for(l= iy;l<=ay;l++)
		for(k= ix;k<=ax;k++) if(k|l) a+= est[j-l][i-k] * m[l+U][k+M];
		if(a<0) a= 0; if(a>255) a= 255;
		flt[j][i]= center*inp[j][i] - a;
	}
}

/*
**	fir() : FIR filter
**	 input: p1, psf: m[][]
**	output: p2
*/
void
fir(int sx,int sy, Sif *p1, Sif *p2,Mt m[V][H])
{
	int i,j,k,l,x1,x2,y1,y2,v;

	for(j=0;j<sy;j++)
	for(i=0;i<sx;i++){
		double a= 0.5;

		x1= -M; if(i+x1< 0) x1= -i;
		x2=  M-1; if(i+x2>sx) x2= sx-i;
		y1= -U; if(j+y1< 0) y1= -j;
		y2=  U-1; if(j+y2>sy) y2= sy-j;

		for(l= y1;l<y2;l++)
		for(k= x1;k<x2;k++) {
			int da= p1->y[j-l][i-k];
			//da*= da;
			a+= da* m[l+U][k+M];
			}
		//v= sqrt(a);
		v= a;
		if(v<0) v= 0; else if(v>255) v= 255;
		p2->y[j][i]= v;
	}
}

read_in(int z, char *n)
{
	FILE *f= fopen(n, "rb"); if(!f) { fprintf(stderr,"%s ropen err\n", n); exit(1); }
	if(fread(&in,1,z,f)<z) { fprintf(stderr,"%s read err\n",n); exit(1); }
	fclose(f);
}

write_out(int z,char *n)
{
	FILE *f= fopen(n, "wb"); if(!f) { fprintf(stderr,"%s wopen err\n",n); exit(1); }
	if(fwrite(&ot,1,z,f)<z) { fprintf(stderr,"%s write err\n",n); exit(1); }
	fclose(f);
}

read_psf(char *n, Mt m[V][H])
{
	FILE *f= fopen(n, "rb"); if(!f) { fprintf(stderr,"%s ropen err\n",n); exit(1); }
	if(fread(m,1,sizeof(Mt)*V*H,f)<sizeof(Mt)*V*H) { fprintf(stderr,"%s read err\n",n); exit(1); }
	fclose(f);
}

Mt c[V*2][H*2];

read_exp_psf(char *n, Mt m[V][H])
{
	int i,j,x,y;
	Mt a[V/2][H/2];
	Mt b[V][H];
	Mt cx,cy,sm,d;
	FILE *f= fopen(n, "rb"); if(!f) { fprintf(stderr,"%s ropen err\n",n); exit(1); }
	if(fread(a,1,sizeof(Mt)*V*H/4,f)<sizeof(Mt)*V*H/4) { fprintf(stderr,"%s read err\n",n); exit(1); }
	fclose(f);

	for(j=0;j<V/2;j++)
	for(i=0;i<H/2;i++) b[j*2  ][i*2  ]= b[j*2  ][i*2+1]= b[j*2+1][i*2  ]= b[j*2+1][i*2+1]= a[j][i];

	cx=0; cy=0;
	for(j=0;j<V;j++)
	for(i=0;i<H;i++) { d= b[j][i]; cx+= d*(i-M); cy+= d*(j-U); sm+= d; }
	x= cx/sm;
	y= cy/sm;
	for(j=0;j<V;j++)
	for(i=0;i<H;i++) c[j-y+V][i-x+H]= b[j][i];

	for(j=0;j<V-1;j++)
	for(i=0;i<H-1;i++) m[j][i]= (c[j+V][i+H] + c[j+V][i+H+1] + c[j+V+1][i+H] + c[j+V+1][i+H+1])/4;
}

write_psf(char *n, Mt m[V][H])
{
	FILE *f= fopen(n, "wb"); if(!f) { fprintf(stderr,"%s wopen err\n",n); exit(1); }
	if(fwrite(m,1,sizeof(Mt)*V*H,f)<sizeof(Mt)*V*H) { fprintf(stderr,"%s write err\n",n); exit(1); }
	fclose(f);
}

void
pr_trace(void)
{
int i;
for(i=0;i<N;i++){ if(i%H==0) printf("\n"); printf("%7.4f ",matrix[i][i+N]); } printf("\n");
}

void
rnd_pel(int sx,int sy, Sif *p)
{
	int i,j;
	for(j=0;j<sy;j++)
	for(i=0;i<sx;i++)p->y[j][i]= rand()&255;
}

void
mult_mat( Mt a[N], Mt b[N])
{
	int i,j;
	for(j=0;j<N;j++) {
		double s= 0;
		for(i=0;i<N;i++) s+= matrix[j][i+N]*a[i];
		b[j]= s;
	}
}
void
mult_mat_sk( Mt a[N], Mt b[N])
{
	int i,j;
	for(j=0;j<N-1;j++) {
		double s= 0;
		for(i=0;i<N-1;i++) s+= matrix[j][i+N]*a[skip_center(i)];
		//for(i=0;i<N-1;i++) { int k= skip_center(i); s+= matrix[j][k+N]*a[k]; }
		b[skip_center(j)]= s;
	}
	b[Center]= 0;
}
void minus_mat(Mt a[N]) { int i; for(i=0;i<N;i++)a[i]= -a[i]; }


void prep_mat(Mt m[V][H]) {
	m[0][0]= 0;
	m[0][M-1]= 0;
	m[0][H-1]= 0;

	m[U-1][0]= 0;
	m[U-1][M-1]= 0;
	m[U-1][H-1]= 0;

	m[V-1][0]= 0;
	m[V-1][M-1]= 0;
	m[V-1][H-1]= 0;
	/*
	int i,j;
	double sum=0;
	Mt s[V][H];

	for(j=0;j<V;j++)
	for(i=0;i<H;i++) s[j][i]=0;

	for(j=1;j<V;j++)
	for(i=1;i<H;i++) s[j][i]= m[j-1][i-1];

	for(j=0;j<V;j++)
	for(i=0;i<H;i++) { int r2= (i-M)*(i-M)+ (j-U)*(j-U); sum+= s[j][i]*= exp(-r2/32.); }

	for(j=0;j<V;j++)
	for(i=0;i<H;i++) m[j][i]= s[j][i]/sum;
	*/
}

gaussian(Mt s[V][H]) { int i,j;
	for(j=0;j<V;j++) for(i=0;i<H;i++) { int r2= (i-M)*(i-M)+(j-U)*(j-U); s[j][i]= 
		//(1-r2/64.)*
			exp(-r2/64.); }
	norm(s,(double)1);
}


Mt b[V][H];

rev(Mt a[V][H]) {
	int i,j;
	for(j=1;j<V;j++) for(i=1;i<H;i++) b[j][i]= a[H-j][H-i];
	//for(j=0;j<H;j++) for(i=0;i<H;i++) b[j][i]= a[H-1-j][H-1-i];
	for(j=0;j<V;j++) for(i=0;i<H;i++) a[j][i]= b[j][i];
}

#ifdef INV_MAT
void
get_mat_fir(int sx, int sy, int x, int y)
{
	get_mat(mat3, x, y);
	norm(mat3,(double)1);
	//pr_mat(mat3);
	fir(sx,sy,&in,&ot,mat3);
}
#endif

rect rect1;

void
mk_rect()
{
	int x,y;
	peak_pos_x= 0;
	peak_pos_y= 0;
	while(peak_pos_x==0 && peak_pos_y==0) { wt(&ot,"set upper left corner"); usleep(100000); }
	rect1.s.x= peak_pos_x;
	rect1.s.y= peak_pos_y;

	peak_pos_x= 0;
	peak_pos_y= 0;
	while(peak_pos_x==0 && peak_pos_y==0) { wt(&ot,"set lower right corner"); usleep(100000); }
	rect1.e.x= peak_pos_x;
	rect1.e.y= peak_pos_y;

	/*
	hline(rect1.s.y, rect1.s.x, rect1.e.x);
	hline(rect1.e.y, rect1.s.x, rect1.e.x);
	vline(rect1.s.x, rect1.s.y, rect1.e.y);
	vline(rect1.e.x, rect1.s.y, rect1.e.y);
	grid= 1;
	*/
}

void
sub_rect(rect *a, rect *b) {
	a->s.x-= b->s.x;
	a->s.y-= b->s.y;
	a->e.x-= b->s.x;
	a->e.y-= b->s.y;
}

void
init_psfa(void) {
	int i,j,k,l;
	for(l=0;l<DY;l++)
	for(k=0;k<DX;k++)
	for(j=0;j< V;j++)
	for(i=0;i< H;i++) psfa[l][k][j][i]= (1./(V*H));
}

//-- deconvolution function --
void
deconv(int sx, int sy, int ex, int ey, int sz, Mt m2[V][H])
{
	int k,x,y;
	rect ir,or,of;// of= ir - or;

#ifdef TST
	rev(m2);
	norm(m2,(double)-1);
	m2[U][M]+= 2;
	pr_mat(m2);
	for(k=0;k<iloop;k++){
		printf("%d\n",k);
		fir(sx,sy,&in,&ot,m2); memcpy(&in,&ot,sz);
		wt(&ot,"in.yuv");
	}
	//norm(m2,(double)-1); m2[U][M]+= 2; pr_mat(m2); fir(sx,sy,&in,&ot,m2);
	//gaussian(mat3); sub(m2,mat3); m2[U][M]+= 1; pr_mat(m2); fir(sx,sy,&in,&ot,m2);
#endif
#ifdef LPC
	auto_correlation(m2);
	pr_mat(m2);
	put_mat_sk(m2); inv_mat(N-1,N*2-1);	// skip-center setting to N-1 x (2N-1) matrix 
	mult_mat_sk((Mt*)m2,(Mt*)mat3);	// inversed matrix x m2 ==> mat3 (with skipping center)
	prep_mat(mat3);				// to remove 8 point big values
	norm(mat3,(double)-1);
	pr_mat(mat3);
	mat3[U][M]+= 2; pr_mat(mat3); fir(sx,sy,&in,&ot,mat3);
#endif
#ifdef INV_MAT
	x= y= -1;
	put_mat(m2); inv_mat(N,N*2);
	do{
		if(x!=xoff||y!=yoff) {
			x= xoff;
			y= yoff;
			sprintf(name,"x= %d, y= %d",x,y);
			get_mat_fir(sx,sy,x,y);
		}
		wt(&ot,name);
	}while(1);
#endif
#ifdef Wiener
	//auto_correlation(m2);
	prep_fft(m2); fft2(Fs,-1); wiener(); fft2(Fs,1); prep_fir(mat3);
	norm(mat3,(double)1); pr_mat(mat3); fir(sx,sy,&in,&ot,mat3);
	//memcpy(&in,&ot,sz); mk_mat4(); fir(sx,sy,&in,&ot,mat4);
#endif
#ifdef IIR_INV
	norm(m2,(double)FP);
	for(k=0;k<iloop;k++){
		memcpy(&ou,&ot,sz);
		iir(sx, sy, &in, &ou, &ot, m2);
		sprintf(name,"%d\n",k);
		wt(&ot,name);
	}
#endif
#ifdef IIR_INV1
	norm(m2,(double)FP1);
	or.s.x= or.s.y= 0;
	or.e.x= PX; or.e.y= PY;
	ir= or;
	sif2dbl(&ir,&in,inp);
	sif2dbl(&ir,&in,est);
	sif2dbl(&ir,&in,flt);
	for(k=0;k<iloop;k++){
		iir1(sx, sy, m2);
		dbl2sif(&or,&ir,flt,&ot); sprintf(name,"%d\n",k); wt(&ot,name);
		memcpy(est,flt,sz);
	}
#endif

#ifdef IIR_INV2
	init_psfa();
#ifdef GE
	sif2g_est(&in,inp);
	sif2g_est(&in,est);
#endif
#ifdef FULL
	or.s.x= or.s.y= 0;
	or.e.x= SX; or.e.y= SY;		// or: full image
	ir= or;
	ir.s.x+= M; ir.e.x-= M;
	ir.s.y+= U; ir.e.y-= U;		// ir: inside of it
	of= ir; sub_rect(&of,&or);	// of: ir - or
	iir2(0,0,0,&or,&ir,&of,m2);
#endif
// point rectangles
#ifdef PART
{
	while(1){
		mk_rect();
		ir= or= rect1;
		or.s.x-= M; or.e.x+= M;		// or: outside of rect
		or.s.y-= U; or.e.y+= U;
		of= ir; sub_rect(&of,&or);	// of: ir - or
		iir2(0,0,0,&or,&ir,&of,m2);
	}
}
#endif
#ifdef DIVD
// divide image
{
	Mt m[V][H]; int i,j,o;
	cpy(m,m2); cpy(psfa[0][0],m);

	for(o=0;o<OLOP;o++) {
	for(j=0;j<DY;j++) {
	for(i=0;i<DX;i++) {
		or.s.x= i*SX/DX; if(i==DX-1) or.e.x= ex; else or.e.x= or.s.x+SX/DX;
		or.s.y= j*SY/DY; if(j==DY-1) or.e.y= ey; else or.e.y= or.s.y+SY/DY;
		ir= or;
#ifdef GE
		if(i==0) ir.s.x+= M; if(i==DX-1) ir.e.x-= M;	// ir: inside of or
		if(j==0) ir.s.y+= U; if(j==DY-1) ir.e.y-= U;	// on the edges of full
#else
		// or: outside of ir, when over edge, it is retrieved, and ir is shrinked
		or.s.x-= M; if(or.s.x< 0) { or.s.x= 0; ir.s.x= M; }
		or.s.y-= U; if(or.s.y< 0) { or.s.y= 0; ir.s.y= U; }
		or.e.x+= M; if(or.e.x>ex) { or.e.x= ex; ir.e.x= ex-M; }
		or.e.y+= U; if(or.e.y>ey) { or.e.y= ey; ir.e.y= ey-U; }
#endif
		if(j&&i==0) cpy(m,m2);
		if(j) avg(m,psfa[j-1][i]);
		if(o){
			//if(i<DX-1) avg(m,psfa[j][i+1]);
			//if(j<DY-1) avg(m,psfa[j+1][i]);
			avg(m,psfa[ j][ i]);
		}
		of= ir; sub_rect(&of,&or);	// of: ir - or
		if(iir2(o,i,j,&or,&ir,&of,m)) break ;
		centroid(0,0,0,0,m);
		cpy(psfa[j][i],m);
	}}
	write_out_psf_jpg(o, name, m);
	}
}	
#endif
#endif
}

void
cut_out(char *n,int sx,int sy, int ex,int ey)
{
	int i,j,c; int d= ex-sx;
	FILE *f= fopen(n, "wb"); if(!f) { fprintf(stderr,"%s wopen error\n",n); exit(1); }
	for(j=sy;j<ey;j++)
	 if(fwrite(&ot.y[j][sx],1,d,f)<d) { fprintf(stderr,"%s write error\n",n); exit(1); }
	sx/=2; sy/=2; ey/=2; d/=2;
	for(c=0;c<2;c++) for(j=sy;j<ey;j++)
	 if(fwrite(&ot.c[c][j][sx],1,d,f)<d) { fprintf(stderr,"%s write error\n",n); exit(1); }
	fclose(f);
}


shrink(char *n)
{
	int i,j,c;
	FILE *f;

	for(j=0;j<PY/2;j++)
	for(i=0;i<PX/2;i++)
		in2.y[j][i]= (in.y[j*2  ][i*2]+ in.y[j*2  ][i*2+1]+
			      in.y[j*2+1][i*2]+ in.y[j*2+1][i*2+1]+2)/4;
	for(c=0;c<2;c++)
	for(j=0;j<PY/4;j++)
	for(i=0;i<PX/4;i++)
		in2.c[c][j][i]=(in.c[c][j*2  ][i*2] + in.c[c][j*2  ][i*2+1]+
				in.c[c][j*2+1][i*2] + in.c[c][j*2+1][i*2+1]+2)/4;

	f= fopen(n, "wb"); if(!f) { fprintf(stderr,"%s wopen err\n",n); exit(1); }
	if(fwrite(&in2,1,sizeof(in2),f)<sizeof(in2)) { fprintf(stderr,"%s write err\n",n); exit(1); }
	fclose(f);
}

void init_flat(Uc *mat) {
	//int i; for(i=0;i<V*H;i++)mat[i]= 1; 
	int i,j; for(j=iy;j<=ay;j++) for(i=ix;i<=ax;i++)mat[(j+U)*H+i+M]= 1;
}

void
get_psf(int x, int y)
{
	int i,j;
	for(j=0;j<V;j++)
	for(i=0;i<H;i++) mat2[j][i]= in.y[y+j-U][x+i-M];
	norm1(mat2,(double)1.);
}

void
readin_psf(char *n)
{
	int i,j,d,x=0,y=0;
	FILE *f= fopen(n,"r");
	if(!f) { fprintf(stderr,"cant read %s\n",n); exit(1); }
	fscanf(f,"%d %d", &x, &y);
	if(x!=H||y!=V) { fprintf(stderr,"psf mismatch\n",n); exit(1); }
	printf("%d x %d\n",x,y);

	for(j=0;j<y;j++) {
	for(i=0;i<x;i++) {
		fscanf(f,"%d",&d);
		printf("%d ",d);
		mat2[j][i]= d+0.25;
	}
	printf("\n");
	}
	printf("readin PSF: %s OK\n",n);
}

//-- usage and main --
void
usage(char *c) {
	fprintf(stderr,
	"usage: %s [size_x size_y] file.yuv\n (size_x <= %d, size_y <= %d) \n",
	c,SX,SY); exit(1);
}
int
main(int c, char **v) {
	int sx=SX,sy=SY,sz= sizeof(Sif);
	char *cm= *v;
	int ex,ey;

#ifdef FLAT
	init_flat(mat);
#endif
	c--; v++;
	while(c){
		     if(strncmp(*v,"-e",2)==0) estm= atoi(*v+2);
		else if(strncmp(*v,"-p",2)==0) psfm= atoi(*v+2);
		else if(strncmp(*v,"-a",2)==0) accl= atoi(*v+2);
		else if(strncmp(*v,"-l",2)==0) iloop= atoi(*v+2);
		else if(**v=='-'){
			fprintf(stderr,"unknown option:%d\n",*v);
			usage(cm);
		}
		else break;
		c--; v++;
	}

	if(c==3) {
		sx= atoi(*v++); if(sx>SX) usage(cm);
		sy= atoi(*v++); if(sy>SY) usage(cm);
	} else if(c==2) read_exp_psf(*v++,mat2);
			//read_psf(*v++,mat2);
			//readin_psf(*v++);
	else if(c!=1) usage(cm);

	read_in(sz,*v);	// read in yuv file

	iwt(name,&in,sx,sy);
	wt(&in,name);

	prep_psf(c,mat2,sx,sy);
	memcpy(&ot,&in,sz);
	memcpy(&ou,&in,sz);
	/*
	cut_out("in4.yuv",1600-512,1200-512,1600,1200);
	cut_out("in3.yuv",800,600,800+512,600+512);
	cut_out("in2.yuv",0,600,0+512,600+512);
	cut_out("in1.yuv",0,200,0+512,200+512);
	cut_out("in0.yuv",152,216,152+256,216+256);
	cut_out("in5.yuv",160,120,1184,680);
	exit(1);
	*/

	//cut_out("in0.yuv",128,12,128+256,12+256); exit(1);
	//cut_out("in6.yuv",400,300,400+400,300+400); exit(1);
	//shrink("in7.yuv"); exit(1);
	//shrink("in8.yuv"); exit(1);

	deconv(0,0,sx,sy,sz,mat2);

	write_out(sz,"o.yuv");
	sprintf(name,"convert -size %dx%d o.yuv out.jpg",SX,SY); system(name);
	system("rm o.yuv");

	//while(1) { wt(&ot,"complete"); usleep(100000); }
	return;
}
