/*
** 			main.c
*/
#include "mpeg.h"
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Xatom.h>

#define FRMT "%s%04d.yuv"
//#define FRMS "%s%04d.sif"
#define FRMS "%s%04d.yuv"

#define SX 500
#define SY 342

#define FRX 1440
#define FRY 486

#define SCX (SX/2)
#define SCY (SY/2)
#define TIC	0.0333
//#define TIC	0.0166

struct sif { unsigned char y[SY][SX]; unsigned char c[2][SCY][SCX]; };
typedef struct	sif SIF;

unsigned char lns[FRY][FRX];
#define TNC 10000
int	yuv= 0; /* 0: sif, 1:yuv, 2:sif2(422), 3:yuv(cat field) */
int	ty[TNC];
int	tu[TNC];
int	tv[TNC];
int	qsif=0;
int	ddt=0;
int	bgc=0;
int	hs= SX;
int	dhs=SX;
int	vs= SY;
int	dvs=SY;
int	vhs= SX*SY;
int	x2= 1;	//
int	cmp=0;
int	gray=0;
int	pdct=0;
double	startt;
double  spent;
int	start=0,endn=1000,fr=1;
int	sync=1;
int	deb=0;
int 	wid=0;
int 	stdinf=0;
int 	loop=0;	//
double	cur;
double	apt;
int	frames=0;
int	pause;
int	step;

SIF	inimg;
char	fname[128];
char	name[128];
char	sifname[128];

double
ReadSysClock() {
	struct timeval tv;
	(void) gettimeofday(&tv, (struct timezone *)NULL);
	return (tv.tv_sec + tv.tv_usec / 1000000.0);
	}

#define VO	3
#define HO	0//8
change() {
	int i,j,c1,c2;

	if(yuv==1) // farme yuv
	for(j=0;j<SY;j++)
	for(i=0;i<SX;i+=2){
		inimg.y[j][i]=   lns[j+VO][2*i+HO+1];
		inimg.y[j][i+1]= lns[j+VO][2*i+HO+3];
		if(j&1){
	inimg.c[0][j>>1][i>>1]= (lns[j+VO+1][2*i+HO]+lns[j+VO][2*i+HO])>>1;
	inimg.c[1][j>>1][i>>1]= (lns[j+VO+1][2*i+HO+2]+lns[j+VO][2*i+HO+2])>>1;
		}
	}
	else if(yuv==3) // filed yuv
	for(j=0;j<SY;j++)
	for(i=0;i<SX;i+=2){
		if((j&1)==0){//top field (=first half)
		inimg.y[j][i]=   lns[j/2][2*i+HO+1];
		inimg.y[j][i+1]= lns[j/2][2*i+HO+3];
		} else { //bottom filed from second half
		inimg.y[j][i]=   lns[SY/2+j/2][2*i+HO+1];
		inimg.y[j][i+1]= lns[SY/2+j/2][2*i+HO+3];
		inimg.c[0][j>>1][i>>1]= (lns[j/2][2*i+HO]+lns[SY/2+j/2][2*i+HO])>>1;
		inimg.c[1][j>>1][i>>1]= (lns[j/2][2*i+HO+2]+lns[SY/2+j/2][2*i+HO+2])>>1;
		}
	}
}

ffread(n,fr,yuv)
char *n;
	{
	int r=0,l,fd; char *p;

	if(yuv) sprintf(name,FRMT,n,fr);
	 else   sprintf(name,FRMS,n,fr);
	if((fd= open(name,O_RDONLY,0))<0){
		fprintf(stderr,"file open failed\n"); exit(1);
		}
	if(yuv==1){ l= sizeof(lns); p= (char *)lns;}
	 else  { l= sizeof(SIF); p= (char *)&inimg;}
	read_frame(fd,p,l);
	close(fd);
	if(yuv==1) change();
	}

cat_file(name, yuv)
char *name;
	{
	int r,l,fd; char *p;

	loop:
        iwt(name,&inimg,dhs,dvs);

	if((fd= open(name,O_RDONLY,0))<0){
		fprintf(stderr,"file open failed\n"); exit(1);
		}

	while(1){
		if(yuv==0){ l= sizeof(SIF); p= (char *)&inimg;}// SIF file
		else      { l= sizeof(lns); p= (char *)lns;}
		if(yuv==3)l-= FRX*6;
		r= read_frame(fd,p,l);
		if(r==0) break;
		if(yuv==1||yuv==3) change();
		cur= ReadSysClock();
		waitt();
		frames++;
       		wt(&inimg, name);
		}
	close(fd);
	if(loop)goto loop;
	}

int
read_frame(fd,p,l)
	{
	if(yuv==2){
		int y,r;
		r= rd(fd,p,SX*SY);
		for(y=0;y<SCY;y++){
			r+= rd(fd,inimg.c[0][y],SCX);
			r+= rd(fd,inimg.c[0][y],SCX);
			}
		for(y=0;y<SCY;y++){
			r+= rd(fd,inimg.c[1][y],SCX);
			r+= rd(fd,inimg.c[1][y],SCX);
			}
		return r;
		}
	return rd(fd,p,l);
	}

rd(fd,p,l)
	{
	int r=0,rl=0;
	while(l){
		r= read(fd, p+r, l);
		rl+= r;
		if(r< 0) exit(1);
		if(r==0) break; /* eof */
		l-=r;
		}
	return rl;
	}

usage0(n)
char *n;
	{
	fprintf(stderr,"Usage: %s [options] file start end\n",n);
	fprintf(stderr," file?????.yuv Abekas format \n");
	fprintf(stderr,"-l: loop display \n");
	fprintf(stderr,"-x: enlarged by 2x2\n");
	fprintf(stderr,"-eN: sync to 30/N Hz\n");
	fprintf(stderr," -: from stdin \n");
	fprintf(stderr,"-yN: 0:sif 1:yuv, 2:sif2(422), 3:catfield (def. 1)\n");
	exit(1);
	}

/*
unsigned char buf11[SY][SX];
grayer()
{
	int i,j;
	for(j=0;j<SY;j++)
	for(i=0;i<SX;i++) {
		buf11[j][i]=inimg.y[j][i];
	}
	for(j=0;j<30;j++)
	for(i=0;i<44;i++) {
		int k,l;
		int st= 256*(44*j+i);
		for(k=0;k<16;k++)
		for(l=0;l<16;l++) {
			inimg.y[j*16+k][i*16+l]= buf11[st/SX][st%SX];
			st++;
		}
	}
	for(j=0;j<SCY;j++)
	for(i=0;i<SCX;i++) {
		inimg.c[0][j][i]= inimg.c[1][j][i]= 128;
	}
}
*/

main0(argc, argv)
int	argc;		
char	*argv[];
{
	int	i,j;
	char *prog;
	prog= argv[0];
	argc--; argv++;
	while(argc){
		     if(strcmp(*argv, "-l")==0) loop=	1;
		else if(strcmp(*argv, "-x")==0) x2=	2;
		else if(strcmp(*argv, "-e")==0) sync=	1;
		else if(strncmp(*argv,"-e",2)==0) sync= atoi(*argv+2);
		else if(strncmp(*argv,"-y",2)==0) yuv = atoi(*argv+2);
		else if(strcmp(*argv, "-")==0)  stdinf=	1;
		else if(**argv == '-'){
			fprintf(stderr,"undefied option\n");
			usage(prog);
		}
		else break;
		argc--; argv++;
	}

	cur= ReadSysClock();
	frames= 0;
	startt= cur;
	apt= cur;

	if(argc==0){
		if(stdinf==0)usage(prog);
	}
	else if(argc==2){
		strcpy(fname,argv[0]);
		endn= start= atoi(argv[1]);
	}
	else if(argc==3){
		strcpy(fname,argv[0]);
		start= atoi(argv[1]);
		endn= atoi(argv[2]);
	}
	else if(argc==1){
		strcpy(fname,argv[0]);
		cat_file(fname, yuv);
		spent= cur-startt;
		fprintf(stderr,"time spent= %f frames=%d\n",spent,frames);
		exit(0);
	}
	else usage(prog);

        iwt(fname,&inimg,dhs,dvs);
	do{
	  for(fr=start;fr<=endn;fr++){
		ffread(fname,fr,yuv);
		//grayer();
		waitt();
        	wt(&inimg, name);
		if(pause){
			fr--;
			if(step){ fr+=step; step= 0; }
			if(fr<start-1)fr= endn-1;
			if(fr>endn-1)fr= start-1;
			usleep(100000);
		}
	  }
	}while(loop);
}


waitt()
{
	cur= ReadSysClock();
	if(sync && pause==0){
		if(apt>cur && apt-cur< 0.1)
			usleep((int)((apt-cur)*1000000));
		else apt= cur;
		apt+= TIC*sync;
	}
}

write_sif(sif)
Uc *sif;
	{
	int fd,l,r;
	sprintf(sifname,"%s%05d.sif",fname,fr);
	fd= open(sifname,O_CREAT|O_RDWR,0666);
	if(fd){
		r= 0; l= sizeof(SIF);
		while(l){
			r= write(fd, sif+r, l);
			if(r< 0) exit(1);
			if(r==0) goto eof1;
			l-=r;
			}
		}
	eof1:
	close(fd);
	}

mkqsif0(sif)
SIF	*sif;
	{
	int i,j;
	Uc *up; Us *sp; Ui *ip;

	sp= (Us *)sif;
	up= (Uc *)sif;
	for(j=0;j<SY/2;j++){
	for(i=0;i<SX/2;i++){
		Us b= *(sp+SX/2), a= *sp++;
		*up++ = ((a&255)+(a>>8)+(b&255)+(b>>8)+2)>>2;
		} sp+= SX/2; up+= SX/2; }
	up= (Uc *)(sif->c[0]);
	for(j=0;j<SCY/2;j++){
	for(i=0;i<SCX/2;i++){
		Us b= *(sp+SCX/2), a= *sp++;
		*up++ = ((a&255)+(a>>8)+(b&255)+(b>>8)+2)>>2;
		} sp+= SCX/2; up+= SCX/2; }
	up= (Uc *)(sif->c[1]);
	for(j=0;j<SCY/2;j++){
	for(i=0;i<SCX/2;i++){
		Us b= *(sp+SCX/2), a= *sp++;
		*up++ = ((a&255)+(a>>8)+(b&255)+(b>>8)+2)>>2;
		} sp+= SCX/2; up+= SCX/2; }

	ip= (Ui *)(sif->y[SCY]);
	for(j=SCY;j<144;j++){
	  	for(i=0;i<SCX/4;i++) *ip++ = 0;
		ip+= SX/8;
		}
	ip= (Ui *)(sif->c[0][SCY/2]);
	for(j=SCY/2;j<72;j++){
		for(i=0;i<SCX/8;i++,ip++)
			*(ip+(SCX*SCY/4))= *ip=
				(128<<24|128<<16|128<<8|128);
		ip+= SCX/8;
		}
	}
SIF	tmp;
mkqsif(sif)
SIF	*sif;
	{
	int i,j,k,l,t,c;
	Uc *p; Ui *ip;

	/* luma */
	/* subsample with horizontal filter*/
	for(j=0;j<SY;j++){
		/* the first pel is not touched */
		tmp.y[j][0]= sif->y[j][0];
		/* the second pel is to be filtered modified */
		p= &sif->y[j][2];
		t=(int)(138*p[0]+88*(p[-1]+p[1])-29*(p[-2]+p[3])+128)>>8;
		if(t<0)t=0; if(t>255)t= 255;
		tmp.y[j][1]= t;
	for(i=2,k=4;i<SX/2-1;i++,k+=2){
		p= &sif->y[j][k];
		t=(int)(138*p[0]+88*(p[-1]+p[1])-29*(p[-3]+p[3])+128)>>8;
		if(t<0)t=0; if(t>255)t= 255;
		tmp.y[j][i]= t;
		}
		/* the last pel is to be filtered modified */
		p= &sif->y[j][SX-2];
		t=(int)(138*p[0]+88*(p[-1]+p[1])-29*(p[-3]+p[1])+128)>>8;
		if(t<0)t=0; if(t>255)t= 255;
		tmp.y[j][SCX-1]= t;
		}

	/* subsample with vertical filter */
		/* the first line is not touched */
		for(i=0;i<SX/2;i++) sif->y[0][i]= tmp.y[0][i];

		/* the second line is filtered modified */
	for(i=0;i<SX/2;i++){
		p= &tmp.y[2][i];
	t= (int)(138*p[0]+88*(p[-SX]+p[SX])-29*(p[-SX*2]+p[SX*3])+128)>>8;
		if(t<0)t=0; if(t>255)t= 255;
		sif->y[1][i]= t;
		}

	for(j=2,l=4;j<SY/2-1;j++,l+=2){
	for(i=0;i<SX/2;i++){
		p= &tmp.y[l][i];
	t= (int)(138*p[0]+88*(p[-SX]+p[SX])-29*(p[-SX*3]+p[SX*3])+128)>>8;
		if(t<0)t=0; if(t>255)t= 255;
		sif->y[j][i]= t;
		}
		}
		/* the last line is filtered modified */
	for(i=0;i<SX/2;i++){
		p= &tmp.y[SY-2][i];
	t= (int)(138*p[0]+88*(p[-SX]+p[SX])-29*(p[-SX*3]+p[SX])+128)>>8;
		if(t<0)t=0; if(t>255)t= 255;
		sif->y[SCY-1][i]= t;
		}

	/* chroma */
	for(c=0;c<2;c++){
	/* subsample with horizontal filter*/
	for(j=0;j<SCY;j++){
		/* the first pel is not touched */
		tmp.c[c][j][0]= sif->c[c][j][0];

		/* the second pel is to be filtered modified */
		p= &sif->c[c][j][2];
		t=(int)(138*p[0]+88*(p[-1]+p[1])-29*(p[-2]+p[3])+128)>>8;
		if(t<0)t=0; if(t>255)t= 255;
		tmp.c[c][j][1]= t;
	for(i=2,k=4;i<SCX/2-1;i++,k+=2){
		p= &sif->c[c][j][k];
		t=(int)(138*p[0]+88*(p[-1]+p[1])-29*(p[-3]+p[3])+128)>>8;
		if(t<0)t=0; if(t>255)t= 255;
		tmp.c[c][j][i]= t;
		}
		/* the last pel is to be filtered modified */
		p= &sif->c[c][j][SCX-2];
		t=(int)(138*p[0]+88*(p[-1]+p[1])-29*(p[-3]+p[1])+128)>>8;
		if(t<0)t=0; if(t>255)t= 255;
		tmp.c[c][j][SCX/2-1]= t;
		}
	/* subsample with vertical filter */
		/* the first line is not touched */
		for(i=0;i<SCX/2;i++) sif->c[c][0][i]= tmp.c[c][0][i];

		/* the second line is filtered modified */
	for(i=0;i<SCX/2;i++){
		p= &tmp.c[c][2][i];
	t= (int)(138*p[0]+88*(p[-SCX]+p[SCX])-29*(p[-SCX*2]+p[SCX*3])+128)>>8;
		if(t<0)t=0; if(t>255)t= 255;
		sif->c[c][1][i]= t;
		}

	for(j=2,l=4;j<SCY/2-1;j++,l+=2){
	for(i=0;i<SCX/2;i++){
		p= &tmp.c[c][l][i];
	t= (int)(138*p[0]+88*(p[-SCX]+p[SCX])-29*(p[-SCX*3]+p[SCX*3])+128)>>8;
		if(t<0)t=0; if(t>255)t= 255;
		sif->c[c][j][i]= t;
		}
		}
		/* the last line is filtered modified */
	for(i=0;i<SCX/2;i++){
		p= &tmp.c[c][SCY-2][i];
	t= (int)(138*p[0]+88*(p[-SCX]+p[SCX])-29*(p[-SCX*3]+p[SCX])+128)>>8;
		if(t<0)t=0; if(t>255)t= 255;
		sif->c[c][SCY/2-1][i]= t;
		}
		}/* c */

	ip= (Ui *)(sif->y[SCY]);
	for(j=SCY;j<144;j++){
	  	for(i=0;i<SCX/4;i++) *ip++ = 0;
		ip+= SX/8;
		}
	ip= (Ui *)(sif->c[0][SCY/2]);
	for(j=SCY/2;j<72;j++){
		for(i=0;i<SCX/8;i++,ip++)
			*(ip+(SCX*SCY/4))= *ip=
				(128<<24|128<<16|128<<8|128);
		ip+= SCX/8;
		}
	}

